<?php
/***** BEGIN MIT LICENSE BLOCK *****
 *
 * Copyright (C) 2012 Esponce d.o.o.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 ***** END MIT LICENCE BLOCK *****/
 
/**************************************************************************************//**
 * Generates QR Code URL
 ******************************************************************************************/
class EsponceQRCodeAPI
{
	public function getURL($content, $format = "png", $version = null, $size = null, $padding = null, $em = null, $ec = null, $foreground = null, $background = null, $attachment = false)
	{
		$query = "content=" . urlencode($content);
		if (!empty($format)) $query .= "&format=$format";
		if (!empty($version)) $query .= "&version=$version";
		if (!empty($size)) $query .= "&size=$size";
		if (!empty($padding) || $padding == "0" || $padding == 0) $query .= "&padding=$padding";
		if (!empty($em)) $query .= "&em=$em";
		if (!empty($ec)) $query .= "&ec=$ec";
		if (!empty($foreground)) $query .= "&foreground=" . urlencode($foreground);
		if (!empty($background)) $query .= "&background=" . urlencode($background);
		if (!empty($attachment) && $attachment) $query .= "&attachment=true";
		$query .= "&source=wp";
		$url = "http://www.esponce.com/api/v3/generate?" . $query;
		return $url;
	}
	
	public function getShortLink($id)
	{
		return "http://goo.by/$id.png";
	}
}
?>