<?php
/***** BEGIN MIT LICENSE BLOCK *****
 *
 * Copyright (C) 2012 Esponce d.o.o.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 ***** END MIT LICENCE BLOCK *****/

$permalink = @$_GET["permalink"] == "1";

//Editable parameters
$content = @$_GET["content"];
$caption = @$_GET["caption"];
$tooltip = @$_GET["tooltip"];
$alt = @$_GET["alt"];

//Some hidden parameters must stay preserved
$class = @$_GET["class"];
$style = @$_GET["style"];
$width = @$_GET["width"];
$height = @$_GET["height"];

$foreground = @$_GET["foreground"];
if (empty($foreground))
{
	//Default value: solid black
	$foreground = "#000000";
}

$background = @$_GET["background"];
if (empty($background))
{
	//Default value: solid white
	$background = "#FFFFFF";
}

$size = @$_GET["size"];
if (empty($size))
{
	//Default value: each module is 8x8 pixels in size
	$size = 8;
}

$padding = @$_GET["padding"];
if (empty($padding))
{
	//Default value: 4 modules for padding
	$padding = 4;
}

$version = @$_GET["version"];
if (empty($version))
{
	//Default value: auto
	$version = 0;
}

//Other parameters
$em = @$_GET["em"];
$ec = @$_GET["ec"];
$ecc = @$_GET["ecc"];

if (empty($ec) || empty($ecc))
{
	//Default value
	$ecc = "1";
}

switch ($ec)
{
	case "L": $ecc = "0"; break;
	case "M": $ecc = "1"; break;
	case "H": $ecc = "2"; break;
	case "Q": $ecc = "3"; break;
}

$site_url = @$_GET["su"]; //site_url
$admin_url = @$_GET["au"]; //admin_url
$includes_url = $site_url . "wp-includes/";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Esponce QR Code Generator</title>
	<link rel="stylesheet" href="<?php echo $includes_url ?>css/editor-buttons.css" type="text/css" media="all" />
	<link rel="stylesheet" href="<?php echo $includes_url ?>css/editor.css" type="text/css" media="all" /><!-- 3.4.1 -->
	<link rel="stylesheet" href="<?php echo $admin_url ?>css/colors-fresh.css" type="text/css" media="all" />
	<script type="text/javascript" src="<?php echo $includes_url ?>js/tinymce/tiny_mce_popup.js"></script>
	<script type="text/javascript" src="<?php echo $admin_url ?>load-scripts.php?c=1&amp;load=jquery"></script>
	<style type="text/css">
	html, body
	{
		background-color: #F5F5F5;
		margin: 0;
	}

	.howto
	{
		color: #666666;
		display: block;
		font-family: sans-serif;
		font-style: italic;
		cursor: pointer;
	}

	.howto.toggle-arrow, .howto.toggle-arrow-active
	{
		padding-left: 18px;
	}

	#wp-link
	{
		outline: none;
		min-width: 470px;
	}

	#wp-link label input[type="text"]
	{
		width: 260px;
	}

	#wp-link select
	{
		border-style: solid;
		border-width: 1px;
		font-size: 12px;
		margin: 1px;
		padding: 3px;
		margin-top: 5px;
		margin-left: -3px;
		width: 150px;
	}

	#wp-link label span
	{
		width: 90px;
	}

	#wp-link input[type="button"]
	{
		-moz-box-sizing: content-box;
		border-style: solid;
		border-width: 1px;
		cursor: pointer;
		font-size: 12px !important;
		line-height: 13px;
		padding: 3px 8px;
		text-decoration: none;
		/* height: 17px; */
		
		position: absolute;
		//bottom: 7px;
		right: 7px;
	}

	.colorbox
	{
		display: inline-block;
		width: 14px;
		height: 14px;
		border: 1px solid #777777;
		position: relative;
		top: 3px;
		left: -21px;
	}
	
	.colorbox .unknown
	{
		position: absolute;
		display: block;
		width: 14px;
		height: 14px;
		line-height: 14px;
		text-align: center;
		font-size: 11px;
	}

	img#preview
	{
		border: 1px solid #DFDFDF;
	}
	</style>
</head>
<body>

<form id="wp-link">

	<!-- Content -->
	<div id="link-selector">
		<div id="link-options">
			<p class="howto">Enter content for QR Code: message, URL, e-mail address...</p>
			<div>
				<label>
					<textarea id="content" name="content" type="text" tabindex="10" rows="5" style="width: 460px"><?php echo $content; ?></textarea>
				</label>
			</div>
			<!--<div class="link-target" style="margin: 0">
				<label><input type="checkbox" id="postlink" tabindex="11" />Use URL of this post in QR Code</label>
			</div>-->
		</div>
	</div>
	
	<!-- Advanced options -->
	<p class="advanced-header howto toggle-arrow" onclick="esponce_toggle_options(this, 'advanced-options')">Optional parameters</p>
	<div id="advanced-options" style="display: none;">
		<div id="link-options">
			<!-- SEO attributes -->
			<div>
				<label><span>Tooltip</span><input id="tooltip" name="tooltip" type="text" tabindex="21" value="<?php echo $tooltip; ?>" title="Enter text to appear on mouse over ('title' attribute)" /></label>
			</div>
			<div>
				<label><span>img[alt]</span><input id="alt" name="alt" type="text" tabindex="22" value="<?php echo $alt; ?>" title="Enter text for 'alt' attribute" /></label>
			</div>
			
			<!-- Colors -->
			<div>
				<label><span>Module Color</span><input id="foreground" name="foreground" type="text" tabindex="24" value="<?php echo $foreground; ?>" title="Enter color name or #[AA]RRGGBB hex value, e.g. 'black' or '#000000'" /><div id="fgpreview" class="colorbox" style="background: #000000;"><span id="fgunknown" class="unknown" style="display:none;">?</span></div></label>
			</div>
			<div>
				<label><span>Background</span><input id="background" name="background" type="text" tabindex="25" value="<?php echo $background; ?>" title="Enter color name or #[AA]RRGGBB hex value, e.g. 'transparent' or '#00FFFFFF'" /><div id="bgpreview" class="colorbox" style="background: #FFFFFF;"><span id="bgunknown" class="unknown" style="display:none;">?</span></div></label>
			</div>
			
			<!-- Size: module size (number) or image size (width x height) -->
			<div>
				<label><span>Size</span><input id="size" name="size" type="text" tabindex="31" value="<?php echo $size; ?>" style="width: 150px;" title="Enter module size (number between 1 and 20) or image size (width x height where both dimensions are equal)" /></label>
				
				<!-- Predefined module sizes -->
				<!--<label>
					<span>Module Size</span>
					<select id="size" name="size" tabindex="31">
						<?php
						for ($i = 1; $i <= 10; $i++)
						{
							?><option value="<?php echo $i; ?>"<?php echo $size == $i ? ' selected="selected"' : ''; ?>><?php echo "$i" . ($i == 8 ? " (default)" : ""); ?></option><?php
						}
						?>
					</select>
				</label>-->
			</div>
			
			<!-- Padding -->
			<div>
				<label>
					<span>Padding</span>
					<select id="padding" name="padding" tabindex="32" title="Select padding in number of modules">
						<?php
						for ($i = 0; $i <= 4; $i++)
						{
							?><option value="<?php echo $i; ?>"<?php echo $padding == $i ? ' selected="selected"' : ''; ?>><?php echo ($i > 0 ? "$i" : "None") . ($i == 4 ? " (default)" : ""); ?></option><?php
						}
						?>
					</select>
				</label>
			</div>
			
			<!-- QR Code Version -->
			<div>
				<label>
					<span>Version</span>
					<select id="version" name="version" tabindex="33">
						<?php
						for ($i = 0; $i <= 40; $i++)
						{
							?><option value="<?php echo $i; ?>"<?php echo $version == $i ? ' selected="selected"' : ''; ?>><?php echo ($i > 0 ? "$i" : "Auto") . ($i == 0 ? " (default)" : ""); ?></option><?php
						}
						?>
					</select>
				</label>
			</div>
			
			<!-- Character encoding -->
			<input type="hidden" id="em" value="<?php echo $em; ?>" />
			<!--
			<div>
				<label>
					<span>Encode mode</span>
					<select id="em" name="em" tabindex="34">
						<option value="0" selected="selected">byte (default)</option>
						<option value="1">alphanumeric</option>
						<option value="2">numeric</option>
					</select>
				</label>
			</div>
			-->
			
			<!-- Error Correction Level -->
			<div>
				<label>
					<span>ECC</span>
					<select id="ecc" name="ecc" tabindex="35">
						<?php
						$options = array("L", "M (default)", "H", "Q");
						for ($i = 0; $i < 4; $i++)
						{
							?><option value="<?php echo $i; ?>"<?php echo $ecc == "$i" ? ' selected="selected"' : ''; ?>><?php echo $options[$i]; ?></option><?php
						}
						?>
					</select>
				</label>
			</div>
			<!--<input type="hidden" id="ec" value="<?php echo $ec; ?>" />-->
			
			<!-- Auxiliary parameters: "width" and "height" are defined when image is resized by user, class is defined on alignment change, e.g. "aligncenter", etc. -->
			<input type="hidden" id="width" name="width" value="<?php echo $width; ?>" />
			<input type="hidden" id="height" name="height" value="<?php echo $height; ?>" />
			<input type="hidden" id="style" name="style" value="<?php echo $style; ?>" />
			<input type="hidden" id="class" name="class" value="<?php echo $class; ?>" />
		</div>
	</div>
	
	<!-- Preview -->
	<p class="preview-header howto toggle-arrow" onclick="esponce_toggle_options(this, 'preview-options')">QR Code Preview</p>
	<div id="preview-options" style="display: none;">
		<div id="link-options">
			<img id="preview" src="" alt="QR Code" />
			<span id="message"></span>
		</div>
	</div>
	
	<!-- Buttons -->
	<div class="submitbox">
		<div id="wp-link-update">
			<input type="button" tabindex="100" value="Add QR Code" class="button-primary" id="wp-qrcode-insert" name="wp-qrcode-insert" onclick="esponce_insert()" />
		</div>
	</div>
	
</form>

<script type="text/javascript">
	//Array extensions: checks if array contains item
	Array.prototype.contains = function(obj)
	{
		var i = this.length;
		while (i--)
		{
			if (this[i] === obj)
			{
				return true;
			}
		}
		return false;
	}
	
	//Update color boxes
	//document.getElementById("foreground").onkeyup = esponce_refresh_foreground;
	document.getElementById("foreground").onchange = esponce_refresh_foreground;
	//document.getElementById("background").onkeyup = esponce_refresh_background;
	document.getElementById("background").onchange = esponce_refresh_background;
	
	//Refresh preview on text change
	document.getElementById("content").onkeyup = esponce_generate_preview;
	document.getElementById("content").onchange = esponce_generate_preview;
	document.getElementById("size").onchange = esponce_generate_preview;
	document.getElementById("padding").onchange = esponce_generate_preview;
	document.getElementById("version").onchange = esponce_generate_preview;
	document.getElementById("ecc").onchange = esponce_generate_preview;
	
	//Refresh color boxes immediately
	esponce_update_colorbox("fg", document.getElementById("foreground").value);
	esponce_update_colorbox("bg", document.getElementById("background").value);
	
	//Refresh color boxes and QR Code image
	function esponce_refresh_foreground()
	{
		if (esponce_update_colorbox("fg", document.getElementById("foreground").value))
		{
			esponce_generate_preview()
		}
	}
	
	function esponce_refresh_background()
	{
		if (esponce_update_colorbox("bg", document.getElementById("background").value))
		{
			esponce_generate_preview();
		}
	}
	
	/**************************************************************************************//**
	 * Updates color in a small preview box.
	 ******************************************************************************************/
	function esponce_update_colorbox(name, value)
	{
		//Use default value if not manually specified
		if (!value || value.length == 0)
		{
			switch (name)
			{
				case "fg":
					document.getElementById(name + "preview").style.background = "black";
					document.getElementById(name + "unknown").style.display = "none";
					break;
					
				case "bg":
					document.getElementById(name + "preview").style.background = "white";
					document.getElementById(name + "unknown").style.display = "none";
					break
			}
			return true;
		}

		//Regular expression for #AARRGGBB hex string
		var regex = /^(#[0-9A-F]{3,8})$/gi;
		
		//List of available colors (System.Drawing.Color)
		var colors = [ "aliceblue", "antiquewhite", "aqua", "aquamarine", "azure", "beige", "bisque", "black", "blanchedalmond", "blue", "blueviolet", "brown", "burlywood", "cadetblue", "chartreuse", "chocolate", "coral", "cornflowerblue", "cornsilk", "crimson", "cyan", "darkblue", "darkcyan", "darkgoldenrod", "darkgray", "darkgreen", "darkkhaki", "darkmagenta", "darkolivegreen", "darkorange", "darkorchid", "darkred", "darksalmon", "darkseagreen", "darkslateblue", "darkslategray", "darkturquoise", "darkviolet", "deeppink", "deepskyblue", "dimgray", "dodgerblue", "firebrick", "floralwhite", "forestgreen", "fuchsia", "gainsboro", "ghostwhite", "gold", "goldenrod", "gray", "green", "greenyellow", "honeydew", "hotpink", "indianred", "indigo", "ivory", "khaki", "lavender", "lavenderblush", "lawngreen", "lemonchiffon", "lightblue", "lightcoral", "lightcyan", "lightgoldenrodyellow", "lightgray", "lightgreen", "lightpink", "lightsalmon", "lightseagreen", "lightskyblue", "lightslategray", "lightsteelblue", "lightyellow", "lime", "limegreen", "linen", "magenta", "maroon", "mediumaquamarine", "mediumblue", "mediumorchid", "mediumpurple", "mediumseagreen", "mediumslateblue", "mediumspringgreen", "mediumturquoise", "mediumvioletred", "midnightblue", "mintcream", "mistyrose", "moccasin", "navajowhite", "navy", "oldlace", "olive", "olivedrab", "orange", "orangered", "orchid", "palegoldenrod", "palegreen", "paleturquoise", "palevioletred", "papayawhip", "peachpuff", "peru", "pink", "plum", "powderblue", "purple", "red", "rosybrown", "royalblue", "saddlebrown", "salmon", "sandybrown", "seagreen", "seashell", "sienna", "silver", "skyblue", "slateblue", "slategray", "snow", "springgreen", "steelblue", "tan", "teal", "thistle", "tomato", "transparent", "turquoise", "violet", "wheat", "white", "whitesmoke", "yellow", "yellowgreen" ];
		
		//Check if value is hex color or color name
		var supported = (regex.test(value) || colors.contains(value.toLowerCase()));
		if (supported)
		{
			document.getElementById(name + "preview").style.background = value;
			document.getElementById(name + "unknown").style.display = "none";
		}
		else
		{
			document.getElementById(name + "preview").style.background = "transparent";
			document.getElementById(name + "unknown").style.display = "block";
		}
		
		return supported;
	}
	
	/**************************************************************************************//**
	 * Encodes shortcode component value.
	 ******************************************************************************************/
	function esponce_encode_shortcode_value(value)
	{
		//Value must be set to continue
		if (!value) return value;
		
		var result = value;
		result = result.replace(/"/g, '&quot;'); //Escape all double quotes
		result = result.replace(/(\r\n|\r|\n)/g, '&br;'); //New lines
		return result;
	}

	/**************************************************************************************//**
	 * Decodes shortcode component value.
	 ******************************************************************************************/
	function esponce_decode_shortcode_value(value)
	{
		//Value must be set to continue
		if (!value) return value;
		
		var result = value;
		result = result.replace(/&quot;/g, '"'); //Double quotes
		result = result.replace(/&br;/g, '\n'); //New lines
		return result;
	}
	
	/**************************************************************************************//**
	 * Encodes HTML attribute.
	 ******************************************************************************************/
	function esponce_encode_html_attr(value)
	{
		//Value must be set to continue
		if (!value) return value;
		
		var result = value;
		result = result.replace(/"/g, '&quot;'); //Double quotes
		return result;
	}

	/**************************************************************************************//**
	 * Decodes HTML attribute.
	 ******************************************************************************************/
	function esponce_decode_html_attr(value)
	{
		//Value must be set to continue
		if (!value) return value;
		
		var result = value;
		result = result.replace(/&quot;/g, '"'); //Double quotes
		return result;
	}
	
	/**************************************************************************************//**
	 * Gets EC letter from input.
	 ******************************************************************************************/
	function esponce_get_ec_letter()
	{
		var ec = "M";
		
		if (document.getElementById("ec"))
		{
			ec = document.getElementById("ec").value;
		}
		else if (document.getElementById("ecc"))
		{
			var ecc = document.getElementById("ecc").value;
			switch (ecc)
			{
				case "0": ec = "L"; break;
				case "1": ec = "M"; break;
				case "2": ec = "H"; break;
				case "3": ec = "Q"; break;
			}
		}
		
		return ec;
	}
	
	/**************************************************************************************//**
	 * Generates URL to QR Code image.
	 ******************************************************************************************/
	function esponce_generate_url()
	{
		var p = esponce_get_parameters();
		if (!p.content || p.content.length == 0)
		{
			return;
		}
		
		var url = "http://www.esponce.com/api/v3/generate?content=" + encodeURIComponent(p.content) + "&format=png";
		url += (p.foreground && p.foreground.length > 0 ? "&foreground=" + encodeURIComponent(p.foreground) : "");
		url += (p.background && p.background.length > 0 ? "&background=" + encodeURIComponent(p.background) : "");
		
		//Module or image size?
		//url += (size && size.length > 0 && parseInt(size, 10) > 0 && parseInt(size, 10) != 8 /* Default */ ? "&size=" + size : "");
		if (p.size && p.size.length > 0)
		{
			if (parseInt(p.size, 10) > 0 && parseInt(p.size, 10) != 8 /* Default */)
			{
				url += "&size=" + p.size;
			}
			else if (/^\d+\s*[Xx]\s*\d+$/.test(p.size))
			{
				url += "&size=" + p.size.replace(" ", ""); //Trim spaces
			}
		}
		
		url += (p.padding && p.padding.length > 0 && parseInt(p.padding, 10) >= 0 && parseInt(p.padding, 10) != 4 /* Default */ ? "&padding=" + p.padding : "");
		url += (p.version && p.version.length > 0 && parseInt(p.version, 10) > 0 ? "&version=" + p.version : "");
		url += (p.em && p.em.length > 0 ? "&ec=" + p.em : "");
		url += (p.ec && p.ec.length > 0 ? "&ec=" + p.ec : "");
		
		return url;
	}
	
	/**************************************************************************************//**
	 * Gets parameters from HTML form.
	 ******************************************************************************************/
	function esponce_get_parameters()
	{
		//User-defined auxiliary parameters
		//var caption = document.getElementById("caption").value;
		var tooltip = document.getElementById("tooltip").value;
		var alt = document.getElementById("alt").value;
	
		//Hidden parameters, must be passed through
		var width = document.getElementById("width").value;
		var height = document.getElementById("height").value;
		var style = document.getElementById("style").value;
		var className = document.getElementById("class").value;
		while (className && className.indexOf("mceEsponceQRCode") != -1)
		{
			//Remove repeating "mceEsponceQRCode" class
			className = className.replace("mceEsponceQRCode", "");
		}
		
		//User-defined parameters that affect QR Code appearence
		var content = document.getElementById("content").value;
		var foreground = document.getElementById("foreground").value;
		var background = document.getElementById("background").value;
		var size = document.getElementById("size").value;
		while (size && size.indexOf(" ") != -1)
		{
			//Trim all spaces
			size = size.replace(" ", "");
		}
		var padding = document.getElementById("padding").value;
		var version = document.getElementById("version").value;
		var em = document.getElementById("em").value;
		var ec = esponce_get_ec_letter();
		
		var result = {
			//caption: caption,
			tooltip: tooltip,
			alt: alt,
			width: width,
			height: height,
			style: style,
			className: className,
			content: content,
			foreground: foreground,
			background: background,
			size: size,
			padding: padding,
			version: version,
			em: em,
			ec: ec
		};
		
		return result;
	}
	
	/**************************************************************************************//**
	 * Generates a shortcode.
	 ******************************************************************************************/
	function esponce_generate_shortcode()
	{
		var p = esponce_get_parameters();
		
		//Build shortcode
		var code = '[qrcode content="' + esponce_encode_shortcode_value(p.content) + '"';
		//code += (p.caption && p.caption.length > 0 ? ' caption="' + esponce_encode_shortcode_value(p.caption) + '"' : "");
		code += (p.tooltip && p.tooltip.length > 0 ? ' tooltip="' + esponce_encode_shortcode_value(p.tooltip) + '"' : "");
		code += (p.alt && p.alt.length > 0 ? ' alt="' + esponce_encode_shortcode_value(p.alt) + '"' : "");
		code += (p.width && p.width.length > 0 ? ' width="' + p.width + '"' : "");
		code += (p.height && p.height.length > 0 ? ' height="' + p.height + '"' : "");
		code += (p.style && p.style.length > 0 ? ' style="' + p.style + '"' : "");
		code += (p.className && p.className.length > 0 ? ' class="' + p.className + '"' : "");
		code += (p.foreground && p.foreground.length > 0 && p.foreground != "#000000" ? ' foreground="' + p.foreground + '"' : "");
		code += (p.background && p.background.length > 0 && p.background != "#FFFFFF" ? ' background="' + p.background + '"' : "");
		code += (p.size && p.size.length > 0 && (/^\d+\s*[Xx]\s*\d+$/.test(p.size) || ((parseInt(p.size, 10) > 0 && parseInt(p.size, 10) != 8 /* Default */))) ? ' size="' + p.size + '"' : "");
		code += (p.padding && p.padding.length > 0 && parseInt(p.padding, 10) >= 0 && parseInt(p.padding, 10) != 4 /* Default */ ? ' padding="' + p.padding + '"' : "");
		code += (p.version && p.version.length > 0 && parseInt(p.version, 10) > 0 ? ' version="' + p.version + '"' : "");
		code += (p.em && p.em.length > 0 ? ' em="' + p.em + '"' : "");
		code += (p.ec && p.ec.length > 0 ? ' ec="' + p.ec + '"' : "");
		code += ']';
		
		return code;
	}
	
	/**************************************************************************************//**
	 * Generates HTML for rich text editor.
	 ******************************************************************************************/
	function esponce_generate_html()
	{
		var p = esponce_get_parameters();
		var url = esponce_generate_url();
		
		//Build HTML img element
		var code = '<img src="' + url + '"';
		code += (p.alt && p.alt.length > 0 ? ' alt="' + esponce_encode_html_attr(p.alt) + '"' : "");
		code += (p.tooltip && p.tooltip.length > 0 ? ' title="' + esponce_encode_html_attr(p.tooltip) + '"' : "");
		code += (p.width && p.width.length > 0 ? ' width="' + p.width + '"' : "");
		code += (p.height && p.height.length > 0 ? ' height="' + p.height + '"' : "");
		code += ' class="mceEsponceQRCode' + (p.className && p.className.length > 0 ? " " + p.className : "") + '"';
		code += (p.style && p.style.length > 0 ? ' style="' + esponce_encode_html_attr(p.style) + '"' : "");
		code += ' />';
		
		return code;
	}
	
	/**************************************************************************************//**
	 * Generates preview of QR Code.
	 ******************************************************************************************/
	function esponce_generate_preview()
	{
		var url = esponce_generate_url();
		
		var preview = document.getElementById("preview");
		if (url && url.length > 0)
		{
			document.getElementById("message").innerHTML = "";
			preview.style.display = "inline";
			preview.src = url + "&nolog=1&source=wp";
		
			var tooltip = document.getElementById("tooltip").value;
			if (tooltip && tooltip.length > 0)
			{
				preview.title = tooltip;
			}
		}
		else
		{
			preview.style.display = "none";
			document.getElementById("message").innerHTML = "&nbsp;(content is missing)";
		}
	}
	
	/**************************************************************************************//**
	 * Inserts QR Code to blog post.
	 ******************************************************************************************/
	function esponce_insert()
	{
		//Custom parameters from parent window
		var mce = tinyMCEPopup.getWindowArg("mce");
		var editor = tinyMCEPopup.getWindowArg("editor");
		
		//Insert when in HTML mode
		//var content = esponce_generate_shortcode();
		
		//Insert when in Visual mode
		var content = esponce_generate_html();
		
		mce.execCommand('mceInsertContent', false, content);
		
		//Select inserted content: http://stackoverflow.com/questions/1253303/whats-the-best-way-to-set-cursor-caret-position
		//editor.focus(); //Give the editor focus
		//editor.selection.select(editor.dom.select('#_mce_temp_select')[0]); //Select the inserted element
		//editor.selection.collapse(0); //Collapses the selection to the end of the range, so the cursor is after the inserted element
		//editor.dom.setAttrib('_mce_temp_select', 'id', ''); //Remove the temp id
		//tinyMCEPopup.storeSelection();
		
		tinyMCEPopup.close();
	}
	
	/**************************************************************************************//**
	 * Finds iframe that contains this dialog.
	 ******************************************************************************************/
	function esponce_find_iframe()
	{
		var iframes = jQuery("iframe", window.parent.document);
		for (var i = 0; i < iframes.length; i++)
		{
			var iframe = iframes[i];
			if (iframe.src.match(/dialog\.php\?su/gi)) //Current dialog URL
			{
				return iframe;
			}
		}
	}
	
	/**************************************************************************************//**
	 * Toggles advanced options panel.
	 ******************************************************************************************/
	function esponce_toggle_options(sender, name)
	{
		var panel = jQuery('#' + name);
		var iframe = jQuery(esponce_find_iframe());
		var dialog = jQuery(iframe.parents("div[role=dialog]"));

		var self = jQuery(sender);
		if (self.is('.toggle-arrow-active'))
		{
			//Collapse
			self.removeClass('toggle-arrow-active');
		}
		else
		{
			//Expand
			if (name == "preview-options")
			{
				esponce_generate_preview();
			}
			self.addClass('toggle-arrow-active');
		}
		
		//Check which panel is visible
		var advanced = jQuery(".advanced-header").is('.toggle-arrow-active');
		var preview = jQuery(".preview-header").is('.toggle-arrow-active');
		
		//Calculate new height
		var h = 280 + (advanced ? 220 + 50 : 0) + (preview ? 235 : 0);
		dialog.animate({ height: h + 0 }, 100);
		iframe.animate({ height: h - 30 }, 100);
		
		//Fix style
		iframe.css("overflow-x", "hidden");
		
		//Fix dialog position
		var win = jQuery(window);
		panel.slideToggle(100, function()
		{
			/*
			var scroll = win.scrollTop();
			var top = dialog.offset().top;
			var bottom = top + dialog.outerHeight();
			var diff = bottom - win.height();
			
			if (diff > scroll)
			{
				dialog.animate({ top: diff < top ?  top - diff : scroll }, 100);
			}
			*/
		});
	}
</script>

</table>
</body>
</html>
